;												
; SIGNAL-AUSFALL-DETEKTOR						
; Bernhard.Erfurt@gmx.de						
; 16.03.2014									
;												


; Anschlussbelegung PINS						
;												
; PB0 ==> 										
; PB1 ==> OUT									
; PB2 ==> 										
; PB3 ==> 										
; PB4 ==> 										
; PB5 ==> 										
; PB6 ==> Quarz									
; PB7 ==> Quarz									
;												
; PC0 ==> TRIGGER-OUT							
; PC1 ==> 										
; PC2 ==> 										
; PC3 ==> 										
; PC4 ==> 										
; PC5 ==> 										
;												
; PD0 ==> 										
; PD1 ==> 										
; PD2 ==> 114kHZ SIGNAL-IN						
; PD3 ==> 										
; PD4 ==> 										
; PD5 ==> LED GRN								
; PD6 ==> LED GELB								
; PD7 ==> LED ROT								

; ATmega8 										
.include "m8def.inc"

.equ TIMERWERT0 					=256-150	;150 C TAKTE																	
.equ FREIGABEWERT					=4			; Anzahl der korrekten Eingangsimpulse, bis Detektor wieder auf "OK" schaltet	
.equ FANGBEREICH					=10			; Anzahl der C TAKTE

; AUSGANG										
.equ AUSGANG_PIN_NR					= 1
.equ AUSGANG_PIN					= PINB
.equ AUSGANG_DDR					= DDRB
.equ AUSGANG_PORT					= PORTB
;  AUSGANG TRIGGER								
.equ TRIGGER_PIN_NR					= 0
.equ TRIGGER_DDR					= DDRC
.equ TRIGGER_PORT					= PORTC
; EINGANG										
.equ EINGANG_PIN_NR					= 2
.equ EINGANG_PIN					= PIND
.equ EINGANG_DDR					= DDRD
.equ EINGANG_PORT					= PORTD
; LED-GRUEN										
.equ LED_GRUEN_PIN_NR				= 5
.equ LED_GRUEN_DDR					= DDRD
.equ LED_GRUEN_PORT					= PORTD
; LED-GELB										
.equ LED_GELB_PIN_NR				= 6
.equ LED_GELB_DDR					= DDRD
.equ LED_GELB_PORT					= PORTD
; LED-ROT										
.equ LED_ROT_PIN_NR					= 7
.equ LED_ROT_DDR					= DDRD
.equ LED_ROT_PORT					= PORTD


.def WertTIMER	= R9
.def NULL		= R10

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def FREIGABE=R25


.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0				

rjmp RESET      	 ; Reset Handler                           			  
rjmp EXT_INT0   ; IRQ0 Handler                      						
rjmp INTERRUPT_ERROR ;rjmp EXT_INT1   ; IRQ1 Handler                      
rjmp INTERRUPT_ERROR ;rjmp TIM2_COMP  ; Timer2 Compare Handler            
rjmp INTERRUPT_ERROR ;rjmp TIM2_OVF   ; Timer2 Overflow Handler           
rjmp INTERRUPT_ERROR ;rjmp TIM1_CAPT  ; Timer1 Capture Handler            
rjmp INTERRUPT_ERROR ;rjmp TIM1_COMPA ; Timer1 CompareA Handler           
rjmp INTERRUPT_ERROR ;rjmp TIM1_COMPB ; Timer1 CompareB Handler           
rjmp INTERRUPT_ERROR ;rjmp TIM1_OVF   ; Timer1 Overflow Handler           
rjmp TIM0_OVF	; Timer0 Overflow Handler           				  		
rjmp INTERRUPT_ERROR ;rjmp SPI_STC    ; SPI Transfer Complete Handler     
rjmp INTERRUPT_ERROR ;rjmp USART_RXC  ; USART RX Complete Handler         
rjmp INTERRUPT_ERROR ;rjmp USART_UDRE ; UDR Empty Handler                 
rjmp INTERRUPT_ERROR ;rjmp USART_TXC  ; USART TX Complete Handler         
rjmp INTERRUPT_ERROR ;rjmp ADC        ; ADC Conversion Complete Handler   
rjmp INTERRUPT_ERROR ;rjmp EE_RDY     ; EEPROM Ready Handler              
rjmp INTERRUPT_ERROR ;rjmp ANA_COMP   ; Analog Comparator Handler         
rjmp INTERRUPT_ERROR ;rjmp TWSI       ; Two-wire Serial Interface Handler 
rjmp INTERRUPT_ERROR ;rjmp SPM_RDY    ; Store Program Memory Ready Handler


; Unkorrekten Interrupt Aufruf 						
INTERRUPT_ERROR:
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	rcall wait_100ms
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus  
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	rcall wait_100ms
	rjmp INTERRUPT_ERROR



RESET:                        
;STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
;													
	clr NULL
	ldi temp,(TIMERWERT0)
	mov WertTIMER,temp
; PORT B initialisieren								
	ldi temp, 0b00000000	; 
	out DDRB, temp
; PORT B setzen										
	ldi temp, 0b00000000	; 
	out PORTB, temp				
; PORT C initialisieren								
	ldi temp, 0b00000000	; 
	out DDRC, temp
; PORT C setzen										
	ldi temp, 0b00000000	; 
	out PORTC, temp				
; PORT D initialisieren								
	ldi temp, 0b00000000	; 
	out DDRD, temp
; PORT D setzen										
	ldi temp, 0b00000000	; 
	out PORTD, temp	
; PORT LED											
	; auf AUSGANG									
	sbi (LED_GRUEN_DDR),(LED_GRUEN_PIN_NR)		; GRN	
	sbi (LED_GELB_DDR),(LED_GELB_PIN_NR)		; GELB	
	sbi (LED_ROT_DDR),(LED_ROT_PIN_NR)			; ROT	
	; LEDs an										
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an	
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  an	
; PORT AUSGANG										
	sbi (AUSGANG_DDR),(AUSGANG_PIN_NR)			; auf AUSGANG	
	cbi (AUSGANG_PORT),(AUSGANG_PIN_NR)			; auf LOW		
; PORT-TRIGGER										
	sbi (TRIGGER_DDR),(TRIGGER_PIN_NR)			; auf AUSGANG	
	sbi (TRIGGER_PORT),(TRIGGER_PIN_NR)			; auf HIGH		
; PORT EINGANG										
	cbi (EINGANG_DDR),(EINGANG_PIN_NR)			; auf EINGANG	
	sbi (EINGANG_PORT),(EINGANG_PIN_NR)			; PULL-UP ein	
; WDR_INITIALISIERUNG								
;	rcall WDR_INITIALISIERUNG
; NEUSTART_MIT_WDR									
;	rcall NEUSTART_MIT_WDR
; LED-TEST											
	rcall LED_TEST
; EXTERNER_INTERUPT_INITIALISIEREN					
	rcall EXTERNER_INTERUPT_INITIALISIEREN
	rcall EXTERNER_INTERRUPT_AKTIVIEREN
; TIMER												
	rcall TIMER0_INITIALISIERUNG
	rcall TIMER_AKTIVIEREN
; Interrupts aktivieren								
	sei


; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
;	WDR
	SLEEP
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "DETEKTOR_INTERRUPT.asm"
.include "DETEKTOR_TIMER.asm"
.include "DETEKTOR_SONSTIGES.asm"
.include "DETEKTOR_WAIT_16MHZ.asm"		; 16 MHz	

