; ##############################################################################
; ##############################################################################
; ##############################################################################
;																			
; SLEEP+INT0+INT1 (externer Interrupt) konfigurieren						
;																			
; MCUCR => SE SM2 SM1 SM0 ISC11 ISC10 ISC01 ISC00 							
; SM2 SM1 SM0 Sleep Mode													
;*0   0   0   Idle															
; 0   0   1   ADC Noise Reduction											
; 0   1   0   Power-down													
; 0   1   1   Power-save													
; 1   0   0   Reserved														
; 1   0   1   Reserved														
; 1   1   0   Standby(1)													
;																			
;ISC11 ISC10 Description													
; 0 	0 	The low level of INT1 generates an interrupt request.			
; 0 	1 	Any logical change on INT1 generates an interrupt request.		
; 1 	0 	The falling edge of INT1 generates an interrupt request.		
; 1 	1 	The rising edge of INT1 generates an interrupt request.			
;																			
;ISC01 ISC00 Description													
; 0 	0 	The low level of INT0 generates an interrupt request.			
; 0 	1 	Any logical change on INT0 generates an interrupt request.		
; 1 	0 	The falling edge of INT0 generates an interrupt request.		
; 1 	1 	The rising  edge of INT0 generates an interrupt request.		
;																			
EXTERNER_INTERUPT_INITIALISIEREN:
	ldi temp,(1<<SE)|(0<<SM2)|(0<<SM1)|(0<<SM0)|(0<<ISC11)|(0<<ISC10)|(0<<ISC01)|(1<<ISC00) 
	out MCUCR,temp

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EXTERNER_INTERRUPT_AKTIVIEREN:
;																			
; INT0+INT1 (externer Interrupt)aktivieren									
;																			
; GICR => INT1 INT0 - - - - IVSEL IVCE 										
; General Interrupt Control													
;																			
	ldi temp, (0<<INT1)|(1<<INT0)|(0<<IVSEL)|(0<<IVCE)   
    out GICR, temp 
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EXT_INT0:
	in TEMP1, TCNT0		; TIMER0 auslesen		
	out TCNT0,WertTIMER	; TIMER0 Startwert		
;-------------------------------------------------------------------------------
AUSWERTUNG:
	cpi temp1,(TIMERWERT0+68-FANGBEREICH)
	brlo AUSWERTUNG_ERROR1
	breq AUSWERTUNG_ERROR1

	cpi temp1,(TIMERWERT0+68+FANGBEREICH)
	brsh AUSWERTUNG_ERROR2
;-------------------------------------------------------------------------------
AUSWERTUNG_OK:
	tst FREIGABE
	breq AUSWERTUNG_OK_w
	dec FREIGABE
	reti
AUSWERTUNG_OK_w:
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus	
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB aus	
	sbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  aus	

	cbi (AUSGANG_PORT),(AUSGANG_PIN_NR)			; auf LOW	
	sbi (TRIGGER_PORT),(TRIGGER_PIN_NR)			; auf HIGH	
reti	
;-------------------------------------------------------------------------------
AUSWERTUNG_ERROR1:
	ldi FREIGABE,(FREIGABEWERT)

	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN an	
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB aus	

	sbi (AUSGANG_PORT),(AUSGANG_PIN_NR)			; auf HIGH	
	cbi (TRIGGER_PORT),(TRIGGER_PIN_NR)			; auf LOW	
reti
;-------------------------------------------------------------------------------
AUSWERTUNG_ERROR2:
	ldi FREIGABE,(FREIGABEWERT)

	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus	
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	


	sbi (AUSGANG_PORT),(AUSGANG_PIN_NR)			; auf HIGH	
	cbi (TRIGGER_PORT),(TRIGGER_PIN_NR)			; auf LOW	
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
